<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:dk="kelis.fr:dokiel" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:xhtml="http://www.w3.org/1999/xhtml" xmlns:java="http://xml.apache.org/xslt/java" xmlns:redirect="com.scenari.xsldom.xalan.lib.Redirect" extension-element-prefixes="redirect" exclude-result-prefixes="sc sp dk xhtml java">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="no" omit-xml-declaration="yes"/>
	<xsl:param name="vAgent"/>
	<xsl:param name="vDialog"/>
	<xsl:variable name="vExcludedItemsSgn">(@sfile_gif|@sfile_jpg_jpeg|@sfile_png|@dk_screenSeq|@sfile_swf|@sfile_mp4_f4v|@sfile_flv|@sfile_odg|@sfile_ods|@sfile_pdf|@dk_code|@sfileany_und|@sfile_xml)\b.*</xsl:variable>
	<xsl:variable name="vExcludedItemsTypes">sfile_gif|sfile_jpg_jpeg|sfile_png|dk_screenSeq|sfile_swf|sfile_mp4_f4v|sfile_flv|sfile_odg|sfile_ods|sfile_pdf|dk_code|sfileany_und|sfile_xml</xsl:variable>
	<xsl:template match="*">
		<xsl:variable name="vRequest">
			<redirect:serialize omit-xml-declaration="yes" method="xml">
				<where>
					<exp uiCrit="critSrcScope" type="LinkDesc" path="{java:getSrcUri(srcFileAgent())}"/>
					<not uiOp="or">
						<exp type="ItemSgnRegexp" uiCrit="critItemType" regexpSgn="{$vExcludedItemsSgn}" uiTypes="{$vExcludedItemsTypes}"/>
					</not>
				</where>
			</redirect:serialize>
		</xsl:variable>
		<xsl:value-of select="execute(initBuffer('ctrlItems',java:java.util.HashSet.new()), initBuffer('ctrlUrl',java:java.util.HashSet.new()))"/>
		<xsl:value-of select="getContent(currentModel(), 'ctrlUrl')" disable-output-escaping="yes"/>
		<xsl:for-each select="searchAgents($vRequest, 'ctrlUrl')">
			<xsl:value-of select="getContent(codeAgent(.))" disable-output-escaping="yes"/>
		</xsl:for-each>
	</xsl:template>
</xsl:stylesheet>