<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xslt/java" xmlns:xalan="http://xml.apache.org/xalan" xmlns:dk="kelis.fr:dokiel" exclude-result-prefixes="sc sp dk java xalan">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="no" omit-xml-declaration="yes"/>
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>
	<xsl:variable name="vId" select="alphaHash(getIdNode(..))"/>
	<xsl:variable name="vFileProps" select="parseXml(getProps(gotoSubModel(sp:img),''))/props/file"/>
	<xsl:variable name="vImgProps" select="parseXml(getProps(gotoSubModel(sp:img),''))/props/image"/>
	<xsl:variable name="vRatio" select="$vImgProps/@transformedWidth div $vImgProps/@nativeWidth"/>
	<xsl:variable name="vImgBox" select="concat('0,0,',$vImgProps/@nativeWidth,',',$vImgProps/@nativeHeight)"/>
	<xsl:variable name="vHasZoneTitles" select="boolean(//dk:screenZoneMeta/sp:title/text())"/>
	<xsl:template match="*" xmlns:scmath="xalan://eu.scenari.modeling.util.Math" xmlns:scimutil="xalan://eu.scenari.transform.img.ImageMagickUtil">
		<table>
			<tr>
				<td class="screen">
					<xsl:variable name="vTransformZones">
						<xsl:value-of select="concat('&amp;', scimutil:getTransformPrefix($vFileProps/@outType))"/>
						<xsl:variable name="vFillColor" select="genProp('dokiel.screen.zone.fill-color', '#FFF3')"/>
						<xsl:variable name="vStrokeColor" select="genProp('dokiel.screen.zone.stroke-color', 'gray')"/>
						<xsl:variable name="vStrokeWidth" select="genProp('dokiel.screen.zone.strokeWidth-int', '1')"/>
						<xsl:variable name="vStrokeType" select="genProp('dokiel.screen.zone.strokeType-alpha', 'dashed')"/>
						<xsl:variable name="vLabelColor" select="genProp('dokiel.screen.zone.label-color', '#000A')"/>
						<xsl:variable name="vFontColor" select="genProp('dokiel.screen.zone.font-color', 'white')"/>
						<xsl:variable name="vFontSize" select="genProp('dokiel.screen.zone.fontSize-float', '10')"/>
						<xsl:for-each select="sp:zone[position()&lt;11]">
							<xsl:variable name="vShape" select="dk:screenZoneMeta/sp:geo/sp:shape/text()"/>
							<xsl:variable name="vCoords" select="scmath:coordsRatio(scmath:coordsCrop(dk:screenZoneMeta/sp:geo/sp:coords/text(),$vImgBox),$vRatio)"/>
							<xsl:value-of select="scimutil:getDrawShapeFragment($vShape,scmath:coordsRound($vCoords), $vFillColor, $vStrokeColor, $vStrokeWidth, $vStrokeType)"/>
						</xsl:for-each>
						<xsl:for-each select="sp:zone[position()&lt;11]">
							<xsl:variable name="vShape" select="dk:screenZoneMeta/sp:geo/sp:shape/text()"/>
							<xsl:variable name="vCoords" select="scmath:coordsRatio(scmath:coordsCrop(dk:screenZoneMeta/sp:geo/sp:coords/text(),$vImgBox),$vRatio)"/>
							<xsl:variable name="vLabelText">
								<xsl:number format="1"/>
							</xsl:variable>
							<xsl:value-of select="scimutil:getDrawLabelFragment($vLabelText,scmath:coordsRound(scmath:coordsTopLeft($vCoords)), $vLabelColor, $vFontColor, $vFontSize)"/>
						</xsl:for-each>
						<xsl:value-of select="'%20%24dst'"/>
					</xsl:variable>
					<img src="{computeStrAgent('//', concat('res:src=src:', $vFileProps/@source, ';', $vFileProps/@transform, $vTransformZones))}" width="{$vImgProps/@transformedWidth}" height="{$vImgProps/@transformedHeight}" alt=""/>
				</td>
				<xsl:if test="$vHasZoneTitles">
					<td class="titles">
<div>
						<ol>
							<xsl:for-each select="sp:zone[position()&lt;11]">
								<xsl:variable name="vZneTi" select="dk:screenZoneMeta/sp:title"/>
								<li>
									<span>
										<xsl:value-of select="if($vZneTi, concat(' ',$vZneTi), ' ...')"/>
									</span>
								</li>
							</xsl:for-each>
						</ol>
						<xsl:if test="count(sp:zone)&gt;10">
							<div class="extraZones">etc...</div>
						</xsl:if>
</div>
					</td>
				</xsl:if>
			</tr>
		</table>
	</xsl:template>
</xsl:stylesheet>